// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UActorComponent.h"
#include "ISCW_UObject.h"
#include <memory>
#include <string>
#include <vector>

using std::vector;
using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_USceneComponent;

	class ISCW_AActor : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_AActor() = default;
		
		virtual void Destroy() = 0;
		
		virtual void GetComponents(vector<ISCW_UActorComponentPtr>& OutComponents, bool bIncludeFromChildActors = false) const = 0;

		virtual shared_ptr<ISCW_USceneComponent> GetRootComponent() const = 0;

		virtual void PostEditMove(bool bFinished) = 0;

		virtual void RerunConstructionScripts() const = 0;

		virtual shared_ptr<ISCW_AActor> ToAActorPtr() = 0;
		virtual shared_ptr<const ISCW_AActor> ToAActorPtr() const = 0;
	};

	using ISCW_AActorConstPtr = shared_ptr<const ISCW_AActor>;
	using ISCW_AActorPtr = shared_ptr<ISCW_AActor>;
} // namespace Sourcify